<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;

/**
 * Class PocetKontrolPodlaKategorieVozidla
 *
 * @package Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects
 */
final class PocetKontrolPodlaKategorieVozidla implements PocetKontrol
{
    /**
     * @var string
     */
    private string $kategoria;

    /**
     * @var int
     */
    private int $pocet;

    /**
     * PocetKontrolPodlaKategorieVozidla constructor.
     *
     * @param string $kategoria
     * @param int    $pocet
     */
    public function __construct(string $kategoria, int $pocet)
    {
        $this->kategoria = $kategoria;
        $this->pocet = $pocet;
    }

    /**
     * @return string
     */
    public function kategoria(): string
    {
        return mb_strtoupper($this->kategoria);
    }

    /**
     * @return int
     */
    public function pocet(): int
    {
        return $this->pocet;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaKategorieVozidla $pocetKontrolPodlaKategorieVozidla
     *
     * @return $this
     */
    public function navysitPocet(self $pocetKontrolPodlaKategorieVozidla): self
    {
        if ($pocetKontrolPodlaKategorieVozidla->kategoria !== $this->kategoria) {
            throw new InvalidArgumentException('Navysenie poctu kontrol podla inej kategorie vozidla nie je mozne.');
        }

        return new self(
            $this->kategoria,
            $this->pocet + $pocetKontrolPodlaKategorieVozidla->pocet()
        );
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaKategorieVozidla $pocetKontrolPodlaKategorieVozidla
     *
     * @return bool
     */
    public function equalsKategoria(self $pocetKontrolPodlaKategorieVozidla): bool
    {
        return $this->kategoria() === $pocetKontrolPodlaKategorieVozidla->kategoria();
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return [
            'kategoria' => $this->kategoria,
            'pocet' => $this->pocet,
        ];
    }

    /**
     * @return string
     */
    public function jsonSerialize(): string
    {
        return json_encode($this->toArray());
    }
}
